<?php
class AdvOntoGomoTree {

   var $_kernel;
   //var $nodeType = "MetaEquality";      //  
   var $baseServName = "AdvOntoGomoTree";  //    (  -  services,  ,   extensions)

   function AdvOntoGomoTree () {
     global $xcKernel;
     include($this->baseServName.".methodTable.php");
     $this->_kernel = $xcKernel;
   }


   // ----------------------------       ---------------------------
   // -------------------       XML  -------------------

  /**
   * @param id ID of root node
   * @param depth max depth of subtree
   * @return XML-line for subtree for current node
   * @access remote
   */
    function getExtXML($nodetype, $id, $depth) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        return $kernel->amfResultOk($service->getExtXMLTree($this->nodeType, $id, $depth));
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

    /**
   * @param id ID of root node
   * @param depth max depth of subtree
   * @return XML-line for subtree for current node
   * @access remote
   */
    function backupConceptSQL($nodetype, $id, $depth) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        return $kernel->amfResultOk($service->backupConceptSQL($this->nodeType, $id, $depth));
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

   // --------------          --------------

  /**
   * Returns complex information about node by id: info, parents, siblings and children
   * @param id node ID
   * @return array: info, parents, siblings and children
   * @access remote
   */
    function getInfoLink($nodetype, $id) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        //$result["msg"] = $id;
        $result["info"] = $service->getInfo($this->nodeType,$id);
        $result["parents"] = $service->getParents($this->nodeType,$id);
        $result["siblings"] = $service->getSiblings($this->nodeType,$id);
        $result["children"] = $service->getChildren($this->nodeType,$id);
        return $kernel->amfResultOk($result);
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

  /**
   * Returns simple information about node by id
   * @param id node ID
   * @return node info
   * @access remote
   */
    function getInfo($nodetype, $id) {

      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        return $kernel->amfResultOk($service->getInfo($this->nodeType,$id));
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }


   // ------------------------       ------------------------
   // ------------    (., ., . )  -------------


  /**
   * Add new node with one parent
   * @return new node id
   * @access remote
   */
    function addNode($nodetype, $parentid, $data, $addinfo) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
           return $kernel->amfResultOk($service->addNode($this->nodeType,$parentid,$data,$addinfo));
        } else {
           return $kernel->amfResultError("      .");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

  /**
   * Update node (data and addinfo)
   * @param id node ID
   * @param data new data
   * @param addinfo new addinfo
   * @access remote
   */
    function updateNode($nodetype, $id, $data, $addinfo) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
           return $kernel->amfResultOk($service->setNode($this->nodeType,$id,$data,$addinfo));
        } else {
           return $kernel->amfResultError("      .");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }


  /**
   * Delete opposition
   * @param id opposition ID
   * @param parentid parent's id (if==0 then remove all)
   * @access remote
   */
    function deleteNode($nodetype, $id, $parentid) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
           return $kernel->amfResultOk($service->delNode($this->nodeType,$id,$parentid));
        } else {
           return $kernel->amfResultError("      .");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

    /**
   * Delete opposition
   * @param id opposition ID
   * @param parentid parent's id (if==0 then remove all)
   * @access remote
   */
    function deleteNodeLink($nodetype, $id, $parentid) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
           return $kernel->amfResultOk($service->delNodeLink($this->nodeType,$id,$parentid));
        } else {
           return $kernel->amfResultError("      .");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

  /**
   * Move opposition
   * @param id opposition ID
   * @param oldparentid old parent's id
   * @param newparentid new parent's id
   * @access remote
   */
    function moveNode($nodetype, $id, $oldparentid, $newparentid) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
           return $kernel->amfResultOk($service->moveNode($this->nodeType, $id, $oldparentid, $newparentid));
        } else {
           return $kernel->amfResultError("      .");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

   /**
   * Move node down
   * @param nodetype nodetype string
   * @param id opposition ID
   * @param parentid parent's id
   * @access remote
   */
    function moveNodeDown($nodetype, $id, $parentid) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $srvOnto = $this->_kernel->srvFactory("AdvOntology");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
           //return $kernel->amfResultOk($service->moveNode($this->nodeType, $id, $oldparentid, $newparentid));
           $children = $service->getChildren($nodetype,$parentid);
           $nextId = '';
           foreach($children as $key => $child) {
              if($child["id"] == $id) {
                 $nextId = $children[$key+1]["id"];
                 break;
              }
           }
           if($nextId != '') {
              $l1 = $srvOnto->getLinkByConceptIds($nodetype.'Tree', array($nodetype.'1' => $parentid, $nodetype.'2' => $id));
              $l2 = $srvOnto->getLinkByConceptIds($nodetype.'Tree', array($nodetype.'1' => $parentid, $nodetype.'2' => $nextId));
              //return array('l1' => $l1, 'l2' => $l2);
              $srvOnto->setLink($nodetype.'Tree', $l1["id"], array('_updateTime' => $l2['_updateTime']));
              $srvOnto->setLink($nodetype.'Tree', $l2["id"], array('_updateTime' => $l1['_updateTime']));
              return $kernel->amfResultOk('Yes');
           } else {
              return $kernel->amfResultOk('No');
           }
        } else {
           return $kernel->amfResultError("      .");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

  /**
   * Move node up
   * @param nodetype nodetype string
   * @param id opposition ID
   * @param parentid parent's id
   * @access remote
   */
    function moveNodeUp($nodetype, $id, $parentid) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $srvOnto = $this->_kernel->srvFactory("AdvOntology");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
           //return $kernel->amfResultOk($service->moveNode($this->nodeType, $id, $oldparentid, $newparentid));
           $children = $service->getChildren($nodetype,$parentid);
           $nextId = '';
           foreach($children as $key => $child) {
              if($child["id"] == $id) {
                 $nextId = $children[$key-1]["id"];
                 break;
              }
           }
           if($nextId != '') {
              $l1 = $srvOnto->getLinkByConceptIds($nodetype.'Tree', array($nodetype.'1' => $parentid, $nodetype.'2' => $id));
              $l2 = $srvOnto->getLinkByConceptIds($nodetype.'Tree', array($nodetype.'1' => $parentid, $nodetype.'2' => $nextId));
              //return array('l1' => $l1, 'l2' => $l2);
              $srvOnto->setLink($nodetype.'Tree', $l1["id"], array('_updateTime' => $l2['_updateTime']));
              $srvOnto->setLink($nodetype.'Tree', $l2["id"], array('_updateTime' => $l1['_updateTime']));
              return $kernel->amfResultOk('Yes');
           } else {
              return $kernel->amfResultOk('No');
           }
        } else {
           return $kernel->amfResultError("      .");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

   /**
   * Move node up1
   * @param nodetype nodetype string
   * @param id opposition ID
   * @param parentid parent's id
   * @access remote
   */
    function moveNodeUp1($nodetype, $id, $parentid) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $srvOnto = $this->_kernel->srvFactory("AdvOntology");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
           //return $kernel->amfResultOk($service->moveNode($this->nodeType, $id, $oldparentid, $newparentid));
           $children = $service->getChildren($nodetype,$parentid);
           $nextId = '';
           foreach($children as $key => $child) {
              if($child["id"] == $id && $key != 0) {
                 $nextId = $children[0]["id"];
                 break;
              }
           }
           if($nextId != '') {
              $l1 = $srvOnto->getLinkByConceptIds($nodetype.'Tree', array($nodetype.'1' => $parentid, $nodetype.'2' => $id));
              $l2 = $srvOnto->getLinkByConceptIds($nodetype.'Tree', array($nodetype.'1' => $parentid, $nodetype.'2' => $nextId));
              //return array('l1' => $l1, 'l2' => $l2);
              $newT = strtotime($l2['_updateTime'])-5000;
              $newT2 = date('Y-m-d h:i:s', $newT);

              $srvOnto->setLink($nodetype.'Tree', $l1["id"], array('_updateTime' => $newT2));
              //$srvOnto->setLink($nodetype.'Tree', $l2["id"], array('_updateTime' => $l1['_updateTime']));
              return $kernel->amfResultOk($l1['_updateTime'].' '.$l2[$nodetype.'2'].' '.$l2['_updateTime'].' '.$newT.' '.$newT2);
           } else {
              return $kernel->amfResultOk('No');
           }
        } else {
           return $kernel->amfResultError("      .");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

  /**
   * Copy opposition
   * @param id opposition ID
   * @param newparentid new parent's id
   * @access remote
   */

    function copyNode($nodetype, $id, $newparentid) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
           return $kernel->amfResultOk($service->copyNode($this->nodeType,$id,$newparentid));
        } else {
           return $kernel->amfResultError("      .");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

    /**
   * Get texts by some dia element - specific for Metaphora 2.0!!! (deprecated)
   * @param $nodetype - nodetype
   * @param id opposition ID
   * @access remote
   */
    function getTexts($nodetype, $id) {
       $kernel = $this->_kernel;
       if($kernel->symAlnum($nodetype)) {
          $res = $kernel->srvRunAll('advOntoGomoTree_getTexts_'.$nodetype, array("id" => $id));
          return $kernel->amfResultOk($res["MetaText"]);
       }
    }

    /**
   * Get URL of visual editor
   * @param $nodetype - nodetype
   * @access remote
   */
    function getVisualEditorURL($nodetype) {
      $this->nodeType = $nodetype;
      $kernel = $this->_kernel;
      $service = $this->_kernel->srvFactory("AdvOntologyTree");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
           return $kernel->amfResultOkSessionCache($serviceBase->getVisualEditorURL($this->nodeType),$nodetype);
        } else {
           return $kernel->amfResultError("      .");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }



}

?>