<?php
class XmServerDBSettings {

   var $_kernel;
   //var $nodeType = "MetaEquality";      //  
   var $baseServName = "XmServerDBSettings";  //    (  -  services,  ,   extensions)
   var $nodeType = "XmServerSettings";

   function XmServerDBSettings () {
     global $xcKernel;
     include($this->baseServName.".methodTable.php");
     $this->_kernel = $xcKernel;
   }


   /**
   * @access remote
   */
    function getAllSettings() {
      $kernel = $this->_kernel;
      $servOnto = $this->_kernel->srvFactory("AdvOntology");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        $allConcepts = $servOnto->getAllConcepts($this->nodeType);
        $allRes =  $servOnto->utilStripFields($allConcepts, array("id", "data"));
        return $kernel->amfResultOk($allRes);
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

   /**
   * @access remote
   */
    function getSetting($name) {
      $kernel = $this->_kernel;
      $servOnto = $this->_kernel->srvFactory("AdvOntology");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        //return $kernel->amfResultOkGlobalCache($servOnto->getConceptByData($this->nodeType,$name),$name,1800);
        return $kernel->amfResultOk($servOnto->getConceptByData($this->nodeType,$name));
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

   /**
   * @access remote
   */
    function saveSetting($name, $content) {
      $kernel = $this->_kernel;
      $servOnto = $this->_kernel->srvFactory("AdvOntology");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
           if($kernel->config["xminiConfig"]["servSetttingsProtect"] != "1" || $name=="designXML") {
                $page = $servOnto->getConceptByData($this->nodeType,$name);
                if($page) {
                   $servOnto->setConcept($this->nodeType, $page["id"], $name, $content);
                } else {
                   $servOnto->addConcept($this->nodeType, $name, $content);
                }
                return $kernel->amfResultOk("");
           } else {
                return $kernel->amfResultError("This operation disabled by current server settings");
           }

        } else {
           return $kernel->amfResultError("This operation allowed only for site administrators");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

   /**
   * @access remote
   */
    function delSetting($name) {
      $kernel = $this->_kernel;
      $servOnto = $this->_kernel->srvFactory("AdvOntology");
      $serviceBase = $this->_kernel->srvFactory($this->baseServName);
      if ($serviceBase) {
        if($kernel->_users->IsAdmin()) {
            if($kernel->config["xminiConfig"]["servSetttingsProtect"] != "1") {
                $page = $servOnto->getConceptByData($this->nodeType,$name);
                if($page) {
                   $servOnto->delConcept($this->nodeType, $page["id"]);
                   return $kernel->amfResultOk("");
                } else {
                   return $kernel->amfResultError("Such setting doesn't exists");
                }
            } else {
                return $kernel->amfResultError("This operation disabled by current server settings");
           }
        } else {
           return $kernel->amfResultError("This operation allowed only for site administrators");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }

   /**
   * @access remote
   */
    function installWidget($url) {
      $kernel = $this->_kernel;
      $servOnto = $this->_kernel->srvFactory("AdvOntology");
      $sWidget = $this->_kernel->srvFactory("XmWidgets");
      if ($sWidget) {
        if($kernel->_users->IsAdmin()) {
            if($kernel->config["xminiConfig"]["servSetttingsProtect"] != "1") {
               $result = $sWidget->installWidget($url);
               if($result == "ok") {
                  return $kernel->amfResultOk("ok");
               } else {
                  return $kernel->amfResultError($result);
               }
            } else {
               return $kernel->amfResultError("This operation disabled by current server settings");
            }
        } else {
           return $kernel->amfResultError("This operation allowed only for site administrators");
        }
      } else
        return $kernel->amfResultError($this->baseServName." isn't installed");
    }





}

?>