<?php
class QSUtil {
   function QSUtil () {
      include("QSUtil.methodTable.php");
   }

 /**
   * Return session id
   * @access remote
   */

   function GetSessionID() {
     return session_id();
   }

   /**
   * Try to login the user
   * @access remote
   */
   function Login($username,$password) {
   global $xcKernel;

   if ($existingUser = $xcKernel->_users->LoadUser($username))
    {
      // check password
      if ($existingUser["password"] == md5($password.$xcKernel->_users->config["code0"]))
      {
        $xcKernel->_users->SetUser($existingUser);
        return $xcKernel->amfResultOk($xcKernel->_users->GetUsername());
      }
      else
      {
        return $xcKernel->amfResultError('Incorrect login/password. Try more.');
      }
    } else {
      return $xcKernel->amfResultError('Incorrect login/password. Try more.');
    }

   }

   /**
   * Try to logout the user
   * @access remote
   */

   function Logout() {
     global $xcKernel;
     if($xcKernel->_users->GetUser()) {
        $xcKernel->_users->LogoutUser();
        return $xcKernel->amfResultOk('');
     } else {
       return $xcKernel->amfResultError("You aren't authorized.");
     }
   }

   /**
   * Get username after login
   * @access remote
   */
   function GetUsername() {
    global $xcKernel;
    return $xcKernel->amfResultOk($xcKernel->_users->GetUsername());
   }

   /**
   * Get userinfo
   * @access remote
   */

   function GetUserInfo() {
    global $xcKernel;
    $result = array ();
    if($xcKernel->_users->GetUser()) {
       $result["registered"] = true;
    } else {
       $result["registered"] = false;
    }
    if($xcKernel->srvIsInstalled("AdvOntology")) {
       $advOnto = $xcKernel->srvFactory("AdvOntology");
       $result["id"] = $advOnto->getCurUserId();
    }
    $result["username"] = $xcKernel->_users->GetUsername();
    $result["admin"] = $xcKernel->_users->IsAdmin();
    $result["extensions"] = $xcKernel->srvRunAll('xmGetUserinfo','');
    return $xcKernel->amfResultOk($result);
   }

   /**
   * Get a list of docLoaders
   * @access remote
   */

   function GetLoaderMap() {
     global $xcKernel;
     $handlers = $xcKernel->srvRunAll('xmLoader','');
     $newhand = array ();
     foreach($handlers as $key=>$handler) {
       if(is_array($handler)) {
         foreach($handler as $key1=>$handler1) {
           if(strpos($handler1,'.version')===false) {
              $newhand[$key.'-'.$key1] = $handler1.'?v='.rand(0,1000);
           } else {
              $newhand[$key.'-'.$key1] = $handler1;
           }
         }
       } else {
           if(strpos($handler,'.version')===false) {
              $newhand[$key.'-main'] = $handler.'?v='.rand(0,1000);
           } else {
              $newhand[$key.'-main'] = $handler;
           }
       }
     }

     $result = array();

     $result["modules"] = $newhand;
     $result["settings"] = $xcKernel->config["xminiConfig"];
     if($xcKernel->srvIsInstalled("XmServerDBSettings")) {
       $srvSettings = $xcKernel->srvFactory("XmServerDBSettings");
       $result["settings"] = array_merge($srvSettings->getAllBlocks(), $result["settings"]);

     }
     $result["settings"]["rooturl"] = $xcKernel->config["base_url"];
     $result["settings"]["rewrite_mode"] = $xcKernel->config["rewrite_mode"];
     //$result["debug"] = get_declared_classes();


     return $xcKernel->amfResultOk($result);
   }
}

?>
